﻿using JmpZbPrint.Dialog;
using JmpZbPrint.Model;
using JmpZbPrint.ViewModel;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using JmpZbPrint.View;

namespace JmpZbPrint.PagePartial
{
    /// <summary>
    /// GenEpcWindow.xaml 的交互逻辑
    /// </summary>
    public partial class TagPrintWindow : UserControl
    {
        private TagPrinViewModel vm;
        private MainWindow _window;
        public TagPrintWindow(MainWindow window)
        {
            InitializeComponent();
            _window = window;
            vm = new TagPrinViewModel(window);
            this.DataContext = vm;
            chk_pri.DataContext = vm;
        }
        private object syncObj = new object();
        private void OnDataGridLoadingRow(object sender, DataGridRowEventArgs e)
        {
            lock (syncObj)
            {
                e.Row.Header = e.Row.GetIndex() + 1;
            }
        }
        public void Clearup()
        {
            vm.Cleanup();
        }

        private void ShowPrintLog_Click(object sender, RoutedEventArgs e)
        {
            var win = new PrintLogWindow(_window);
            win.ShowDialog();
        }


        private void pri_win_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            if (!IsVisible)
            {
                _window.printServerHelper.EnableControlEvent -= vm.EnableControl;
            }
        }
    }
}
